#!/usr/bin/env node

var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  __markAsModule(target);
  for (var name2 in all)
    __defProp(target, name2, { get: all[name2], enumerable: true });
};
var __reExport = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toModule = (module2) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};

// templates/typescript/aqu.template.ts
__export(exports, {
  default: () => aqu_template_default
});

// src/utils/packageManager.ts
var import_chalk2 = __toModule(require("chalk"));
var import_execa = __toModule(require("execa"));
var import_inquirer = __toModule(require("inquirer"));

// src/utils/insertArgs.ts
var insertArgs = (str, args) => str.replace(/\${\s*((?:\w|\.)+)\s*}/g, (_, paramName) => paramName in args ? args[paramName] : `\${${paramName}}`);

// src/logger.ts
var import_chalk = __toModule(require("chalk"));
var import_ora = __toModule(require("ora"));

// package.json
var name = "aqu";

// src/logger.ts
var logger = {
  error: (...args) => {
    console.error(import_chalk.default.red(`[${name}]`, ...args));
  },
  fatal: (...args) => {
    logger.error(...args);
    process.exit(1);
  },
  warn: (...args) => {
    console.warn(import_chalk.default.yellow(`[${name}] WARNING:`), ...args);
  },
  info: (...args) => {
    console.log(import_chalk.default.gray(`[${name}]:`), ...args);
  },
  success: (...args) => {
    console.log(import_chalk.default.green(`[${name}]:`, ...args));
  }
};
var logger_default = logger;

// src/messages.json
var unknownPackageManager = "Unknown package manager ${manager} found";

// src/utils/packageManager.ts
var getPackageVersion = async (pkg, manager) => {
  if (manager === "npm" || manager === "pnpm") {
    const { stdout } = await (0, import_execa.default)(manager, ["view", pkg, "version"]);
    return stdout.trim();
  } else if (manager === "yarn") {
    const { stdout } = await (0, import_execa.default)(manager, [
      "info",
      pkg,
      "version",
      "--silent"
    ]);
    return stdout.trim();
  } else {
    logger_default.fatal(insertArgs(unknownPackageManager, {
      manager: import_chalk2.default.bold.red(manager)
    }));
  }
};

// templates/typescript/aqu.template.ts
var templateScript = {
  initialize: async (manager) => ({
    extend: "_base",
    filesToMergePaths: ["package.json", "./example/package.json"],
    templateFilePaths: [
      "package.json",
      "./example/tsconfig.json",
      "./example/src/index.ts",
      "./example/package.json"
    ],
    customArgs: {
      ["versions.typescript"]: await getPackageVersion("typescript", manager),
      ["versions.nodeTypes"]: await getPackageVersion("@types/node", manager)
    }
  })
};
var aqu_template_default = templateScript;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
